<template>
  <div class="container_table m-auto">
        <table class="table table-bordered table-hover">
          <thead>
            <tr>
              <th scope="col" class="bg_color-second attribute_label first_col"></th>
              <th scope="col" v-for="k of attributes" :key="k.id" @click="sortBy(k)"
              class="bg_color-second attribute_label" style="color:white"> {{getLabel(k)}}
              <b-icon :icon="sortIcon(k)" variant="light"></b-icon> &nbsp;</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="feature of features" :key="feature.id"
              :class="{ selected: isSelected(feature) }"
              @click="onClick(feature)"
              @mouseover="highlightFeature(feature)"
              @mouseleave="unHighlightFeature(feature)"
            >
              <td class="bg_color-second attribute_label">
                <button class="btn btn-sm p-0 " style="margin-right:6px;"
                    @click="zoomToFeature(feature)"
                    v-b-tooltip.hover.top.window title="Zoomer sur l'objet">
                      <b-icon icon="zoom-in" variant="light"></b-icon> &nbsp;
                  </button>
              </td>
              <td v-for="k of attributes" :key="k.id">
                <div v-if="!resizing" class="row-content"
                :title="feature.get(k.name)">
                  <template v-if="isLink(feature.get(k.name))">
                    <a target="blank" :href="feature.get(k.name)">{{feature.get(k.name)}}</a>
                  </template>
                  <template v-else>
                      {{feature.get(k.name)}}
                  </template>
                </div>
                <template v-else>
                  {{feature.get(k.name)}}
                </template>

                </td>
              <!-- v-b-tooltip.hover.d1000 -->
            </tr>
          </tbody>
        </table>
  </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/no-this-alias */
/* eslint-disable prefer-destructuring */
import Component from 'vue-class-component';
import BaseComponent from '@/components/BaseComponent';
import LayerConfig from '@/models/map-context/LayerConfig';
import { Feature } from 'ol';
import * as jsts from 'jsts';

import {
  LineString,
  MultiLineString,
  MultiPoint,
  MultiPolygon,
  LinearRing,
  Point,
  Polygon,
  Geometry,
} from 'ol/geom';
import {
  Circle, Fill, Stroke, Style,
} from 'ol/style';
import { addProjection, Projection, addCoordinateTransforms } from 'ol/proj';

@Component({
  props: {
    layer: LayerConfig,
    features: {
      type: Array,
      default: [],
    },
    attributes: {
      type: Array,
      default: [],
    },
    selectedFeatures: {
      type: Array,
      default: [],
    },
  },
  components: {
  },
})
export default class FeatureListTable extends BaseComponent {
  layer!: LayerConfig;

  attributes!:any;

  currentPage = 1;

  perPage = 20;

  rows = 0;

  features!:any;

  allFeatures!:any;

  selectedFeatures:any;

  currentSortAttribute:any;

  currentSortOrderAsc = true;

  parser:any;

  resizing = false;

  highlightStyle = new Style({
    fill: new Fill({
      color: 'rgba(253,255,154,0.7)',
    }),
    stroke: new Stroke({
      color: '#CCCCCC',
      width: 1,
    }),
    image: new Circle({
      radius: 7,
      stroke: new Stroke({
        color: '#CCCCCC',
        lineDash: [],
        width: 2,
      }),
      fill: new Fill({
        color: 'rgba(253,255,154,0.7)',
      }),
    }),
  });

  mounted():void{
    // eslint-disable-next-line no-undef
    this.parser = new jsts.io.OL3Parser();
    this.parser.inject(
      Point,
      LineString,
      LinearRing,
      Polygon,
      MultiPoint,
      MultiLineString,
      MultiPolygon,
    );
    addProjection(new Projection({
      code: 'WGS84',
      units: 'degrees',
    }));

    addCoordinateTransforms(
      'WGS84',
      'EPSG:4326',
      (coordinate) => [coordinate[1], coordinate[0]],
      (coordinate) => [coordinate[1], coordinate[0]],
    );
    // test de colonne resizable => voir les css a activer avec
    // setTimeout(() => { this.addResizableHandles(); }, 1000);
  }

  sortIcon(attribute:any):string {
    if (this.currentSortAttribute === attribute) {
      return this.currentSortOrderAsc ? 'sort-alpha-down' : 'sort-alpha-down-alt';
    }
    return 'arrow-down-up';
  }

  isLink(value:any):boolean {
    if (typeof value === 'string' && value.indexOf('http') === 0) {
      return true;
    }
    return false;
  }

  sortBy(attribute:any) {
    if (this.currentSortAttribute === attribute) {
      this.currentSortOrderAsc = !this.currentSortOrderAsc;
    } else {
      this.currentSortAttribute = attribute;
      this.currentSortOrderAsc = true;
    }
    this.$emit('changeSort', { attribute, ascending: this.currentSortOrderAsc });
  }

  addResizableHandles() {
    console.log('addResizableHandles');
    let thElm:any;
    let startOffset:any;
    const self = this;
    const createResizableColumn = function (col:any, resizer:any) {
    // Track the current position of mouse
      let x = 0;
      let w = 0;
      const mouseMoveHandler = function (e:any) {
        // Determine how far the mouse has been moved
        const dx = e.clientX - x;
        console.log(dx);
        // Update the width of column
        col.style.width = `${w + dx}px`;
        col.style['max-width'] = `${w + dx}px`;
      };

      // When user releases the mouse, remove the existing event listeners
      const mouseUpHandler = function () {
        document.removeEventListener('mousemove', mouseMoveHandler);
        document.removeEventListener('mouseup', mouseUpHandler);
      };
      const mouseDownHandler = function (e:any) {
        // Get the current mouse position
        x = e.clientX;
        self.resizing = true;
        // Calculate the current width of column
        const styles = window.getComputedStyle(col);
        w = parseInt(styles.width, 10);

        // Attach listeners for document's events
        document.addEventListener('mousemove', mouseMoveHandler);
        document.addEventListener('mouseup', mouseUpHandler);
      };

      resizer.addEventListener('mousedown', mouseDownHandler);
    };

    Array.prototype.forEach.call(
      document.querySelectorAll('table th'),
      (th:any) => {
        console.log(th);
        th.style.position = 'relative';

        const grip:any = document.createElement('div');
        grip.innerHTML = '&nbsp;';
        grip.style.top = 0;
        grip.style.right = 0;
        grip.style.bottom = 0;
        grip.style.width = '5px';
        grip.style.position = 'absolute';
        grip.style.cursor = 'col-resize';
        th.appendChild(grip);
        createResizableColumn(th, grip);
      },
    );
  }

  zoomToFeature(feature:any) {
    if (feature.getGeometry().getType() === 'Point') {
      const jstsGeom:any = this.parser.read(feature.getGeometry());
      // create a buffer of X meters
      const buffered = jstsGeom.buffer(500);
      this.getOpenLayersMapService().map.getView().fit(this.parser.write(buffered));
    } else {
      this.getOpenLayersMapService().map.getView().fit(feature.getGeometry());
    }
  }

  beforeDestroy() {
    console.log('beforeDestroy');
  }

  getLabel(k:any):string {
    if (k.label) return k.label;
    return k.name;
  }

  onClick(feature: Feature<any>) {
    this.$emit('onClick', feature);
  }

  highlightFeature(feature: Feature<any>) {
    if (!this.isSelected(feature)) {
      if (feature.setStyle) {
        feature.setStyle(this.highlightStyle);
      } else {
        const f:any = feature;
        f.layerConfig = this.layer;
        this.getMapService().selectionService.addToSelection(f);
      }
    }
  }

  isSelected(feature: any):boolean {
    return this.selectedFeatures.indexOf(feature) >= 0;
  }

  unHighlightFeature(feature: Feature<any>) {
    if (!this.isSelected(feature)) {
      feature.setStyle(undefined);
    }
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.first_col{
  width:80px;
}
.table{
   overflow: auto;
}

.container_table{
  /* max-height: ~"min(25vh, 300px)";*/
  max-width: 100%;
  font-size: 80%;
}
.row-content{
  max-height:20px;
  max-width:200px;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  padding-left: 2px;
}
th{
  position:relative;
  padding:0.2rem;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}
thead{
  position: sticky;
  top: 0;
  left: 0;
  white-space: nowrap;
}
/* test de colonne resizable
table{
  table-layout:fixed;
}
*/
.table td{
  padding:1px;
  min-width:50px;
  border-right: 1px solid gray;
   white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}
.attribute_label{
  text-align:center;
  font-weight: bold;
  cursor:pointer;
}
.expanded tbody{
  overflow:auto;
  max-height:300px;
}
.selected{
  background-color: rgba(253,255,154,0.7) !important;
}

tr:nth-child(even){
    background-color: fade(@first,10%);
}
</style>
